//billerprot.java Q1 2004
//Features:
// <CR><LF> terminated message handling
// new-biller-prot protocol 1.3 (revision 1.3.1)

import java.io.*;
import java.net.*;
//import java.util.*;
import java.util.Enumeration;

public class billerprot {
	static final int version  = 8;
	//static final int protocol = 1;
	static final String protocol = "1.3";
	static String versionstring;

	//Modules
	static loggers    lm;
	static config     cfg;
	static tcpserver  net;
	static data       pd;
	static cmdman     cmd;
	static messages   mesg;

	public int stage;
	final int STAGE_LOADING = 0;
	final int STAGE_RUNNING = 1;
	final int STAGE_STOPPED = 2;
	final int STAGE_QUIT    = 3;
	
	static    boolean bKeepGoing   = false;

//// Receive ////

	public void msgHandler(String port, String in)
	{
		String msg = in.toUpperCase();
		String[] part;

		if (msg.startsWith("PLOGIN:"))
		{
			//PLOGIN:pid:flag:name:pw:ip:macid:contid
			part = in.split(":", 8);
			if (pd.existPlayer(part[3]))
			{
				/* FIX ME */
				/* auth with all data, if bad then add data */
				if (!pd.authPlayer(part[3], part[4]))
				{
					//PBAD:pid:newname:rtext
					//CODE2
					net.sendRaw(port, "PBAD:" + part[1] +
						":0:incorrect password");
					lm.Log("M", "<billerprot> [" +  part[3]
						+ "] incorrect password from " +
						part[5]);
					
					/* FIX ME */
					/* Record number of bad logins... */
					return;
				}
			}
			else
			{
				//Create player (Billing:AllowUnknown)
				pd.createPlayer(part[3], part[4]);
				lm.Log("I", "<billerprot> [" +  part[3] +
					"] new player from " +
					part[5]);
					
				//1.3.1
				//PBAD:pid:newname:rtext
				//newname = 1 (available for reg)
				/* FIX ME */
			}
			
			/* FIX ME */
/*
			if (part[2].equals("1"))
			{
				//Create new player
				//WANTREG:pid
			}
*/
			
			/* FIX ME */
			/* Update security info */
			
			pd.setOnline(part[3], part[1], port);
			//Log here?
			
			String squad     = pd.getSquad(part[3]);
			String billerid  = pd.getBillerID(part[3]);
			String usage     = pd.getUsage(part[3]);
			String firstused = pd.getFirstUsed(part[3]);
			
			//POK:pid:rtext:name:squad:billerid:usage:firstused
			net.sendRaw(port, "POK:" + part[1] + "::" + part[3] +
				":" + squad + ":" + billerid + ":" + usage +
				":" + firstused);
		} else
		if (msg.startsWith("REGDATA:"))
		{
			//REGDATA:pid:data
			part = in.split(":", 3);
			/* FIX ME */
		} else
		if (msg.startsWith("BNR:"))
		{
			//BNR:pid:banner
			part = in.split(":", 3);
			pd.setBanner(pd.getNameByPid(port, part[1]), part[2]);
			lm.Log("I", "<billerprot> {" + pd.getZoneByPort(port) +
				"} [" + pd.getNameByPid(port, part[1]) +
				"] set banner");
		} else
		if (msg.startsWith("PENTERARENA:"))
		{
			//PENTERARENA:pid
			part = in.split(":", 2);
			
			//Send banner
			String name = pd.getNameByPid(port, part[1]);
			String banner = pd.getBanner(name);
			if (banner != null && banner.length() > 0)
			{
				lm.Log("D", "<billerprot> {" +
					pd.getZoneByPort(port) + "} [" + name +
					"] sending banner");
				net.sendRaw(port, "BNR:" + part[1] + ":" +
					banner);
			}
			
			//Check for messages
			int count = mesg.getNewMessageCount(name);
			if (count > 0)
			{
				net.SendMessage(port, part[1], "You have " + count
					+ " new message. Type ?messages to read");
			}
		} else
		if (msg.startsWith("PLEAVE:"))
		{
			//PLEAVE:pid
			part = in.split(":", 2);
			pd.setOffline( pd.getNameByPid(port, part[1]), port);
		} else
		if (msg.startsWith("CHAT:"))
		{
			//CHAT:pid:channel:sound:text
			part = in.split(":", 5);
			/* FIX ME */
			//CHATTXT:channel:sender:sound:text
			//CHAT:pid:number
		} else
		if (msg.startsWith("RMT:"))
		{
			//RMT:pid:destination:sound:text
			part = in.split(":", 5);
			
			//Construct message, excluding pid
			//RMT:pid:sender:sound:text
			String message = ":" + pd.getNameByPid(port, part[1]) +
				":" + part[3] +	":" + part[4];
			
			//Get all ports and pids of recipients
			Enumeration ports = pd.getPorts(part[2]);
			Enumeration pids  = pd.getPids(part[2]);
			if (ports == null || pids == null)
			{
				//destination is offline
				//lm.Log("E", "<billerprot> [" + part[2] + "] " +
				//	"null pointer (remote priv)");
				return;
			}
			
			//Send to all recipients
			//RMT:pid:sender:sound:text
			while (ports.hasMoreElements() &&
				pids.hasMoreElements())
			{
				net.sendRaw((String)ports.nextElement(), "RMT:"+
					(String)pids.nextElement() + message);
			}
		} else
		if (msg.startsWith("RMTSQD:"))
		{
			//RMTSQD:pid:destsquad:sound:text
			part = in.split(":", 5);
			//RMTSQD:destsquad:sender:sound:text
		} else
		if (msg.startsWith("CMD:"))
		{
			//CMD:pid:cmdname:args
			part = in.split(":", 4);
			cmd.cmdHandler(port, part[1], part[2], part[3]);
			//MSG:pid:sound:text
		} else
		if (msg.startsWith("LOG:"))
		{
			//LOG:pid:logtext
			part = in.split(":", 3);
			
			String pid = part[1]; //Use "" + ?
			if (part[1].length() > 0)
				pid = "[pid=" + pid + "] ";
			else
				pid = "";
				
			lm.Log("I", "<billerprot> [port=" + port + "] " +
				pid + part[2]);
		} else
		{
			lm.Log("M", "<billerprot> {" + pd.getZoneByPort(port) +
				"} Unhandled message: " + in);
		}
	}

	public void mainHandler(String port, String in)
	{
		String msg = in.toUpperCase();
		String[] part;

		if (msg.startsWith("SETIDS:"))
		{
			//SETIDS:serverid:groupid:scoreid
			part = in.split(":", 4);
			lm.Log("D", "<billerprot> [" + port + "] " + in);
		} else
		if (msg.startsWith("CONNECT:"))
		{
			//swname token
			String swname = "POCoB v" + versionstring;
			//network token
			String network = cfg.GetStr("Billing", "Network");
			if (network == null) network = "";
		
			//CONNECT:version:swname:zonename:network:password
			part = in.split(":", 6);
			
			//Protocol check
			if (!part[1].equals("" + protocol))
			{
				//CONNECTBAD:swname:billername:reason
				net.sendRaw(port, "CONNECTBAD:" + swname
					+ ":" + network + ":" +
					"bad protocol request g=" + part[1] +
					" b=" + protocol);
					
				lm.Log("I", "<billerprot> [" + part[3] +
					"] bad protocol request g=" + part[1] +
					" b=" + protocol + " (" + part[2] + ")");
				return;
			}
			
			if (pd.existZone(part[3]))
			{
				//Authenticate
				if (!pd.authZone(part[3], part[5]))
				{
					//CONNECTBAD:swname:billername:reason
					net.sendRaw(port, "CONNECTBAD:" + swname
						+ ":" + network + ":" +
						"incorrect password");

					lm.Log("M", "<billerprot> [" +  part[3]
						+ "] incorrect password from " +
						part[4] + ":" + port);
					return;
				}
			}
			else
			{
				//Create new zone entry
				pd.createZone(part[3], part[5]);
				lm.Log("I", "<billerprot> [" +  part[3] +
					"] new zone from " + port + " (" +
					part[4] + ")");
			}
			
			//CONNECTOK:swname:billername
			net.sendRaw(port, "CONNECTOK:" + swname + ":" + network);
			pd.zoneOnline(part[4], part[3], port);
			lm.Log("I", "<billerprot> [" + part[3] + "] " +
				"connected (" +	part[2] + ")");
		} else
		if (msg.startsWith("PING") || msg.startsWith("NOOP"))
		{
			//PING
			//Ignore this
		}
		else
		{
			msgHandler(port, in);
		}
	}

//// Core ////

	public billerprot(loggers lm, config cfg, data pd)
	{
		this.stage = this.STAGE_LOADING;
		
		this.lm  = lm;
		this.cfg = cfg;
		this.pd  = pd;

		this.net  = new tcpserver(lm, cfg, this);
		this.cmd  = new cmdman(lm, cfg, pd, this, net);
		this.mesg = cmd.getMesg(); //hack
		
		versionstring = lm.getAppVersion();
		pd.load();
		mesg.load();
		net.listen();
	}
	
	public void shutdown()
	{
		lm.Log("I", "<billerprot> Saving persistent data");
		pd.setAllOffline();
		pd.flush();
		mesg.flush();
		
		this.stage = this.STAGE_STOPPED;
		net.disconnect();
	}
	
	//hack for tcpserver.java
	public data getDataRef()
	{
		return pd;
	}
}
